
function dbiScriptApplication() {

  app.dbiScriptProperties.dataConfig = "../data/clinic.cfg"
  app.dbiScriptProperties.dataTables.fetchAll = false;

  app.addDefinitionTable("dfnmst","descr","srcdbf","srcfld",{additionalFields:["code"]});
  app.addDefinitionTable("icd9mst","descr",{additionalFields:["code"]});
  app.addDefinitionTable("prcmst","descr",{additionalFields:["code"]});
  app.addFileTable("filemst","srcid","filename","userid","action","occurred","srcdbf","srcfld");
  app.addLinkTable("linkmst","parentid","childid","order","descr");
  app.addPhotoTable("photomst","srcid","filename","descr","order","srcdbf","srcfld");

  var o = app.gui.appendDataTable("patient","Patients","Patient");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.dbiScriptProperties.fields.email.subject = "Test";
  o.dbiScriptProperties.fields.email.body = "This is a test.";
  o.appendRowState("inactv")
  o.appendIconlist("icons","Icons","images",["a.png","b.png","c.png","d.png"]);
  o.appendSelect("sal","Sal",{Mr:"Mr",Mrs:"Mrs",Ms:"Ms",Miss:"Miss",Dr:"Dr",Rev:"Rev"});
  o.appendData("fname","First Name");
  o.appendData("mi","MI",{forceCase:"UPPER"});
  o.appendData("lname","Last Name");
  o.appendSelect("suffix","Suffix",{"Jr":"Jr","Sr":"Sr",II:"II",III:"III",IV:"IV"});
  o.appendData("address1","Address");
  o.appendData("address2","Address ...");
  o.appendQuickpick("city","City");
  o.appendQuickpick("state","State");
  o.appendData("zip","Zip");
  o.appendData("stock","Stock Symbol");
  o.appendWebServiceRequest("stockPrice","Stock Price","http://quote.yahoo.com/d/quotes.csv",{allowManualRefresh:true,httpMethod:"GET",serverErrorDisplay:"console",textAlign:"right"}); // note: Yahoo returns the web service data in csv format but since we're only receiving a single value, we can use the "string" (default) WebServiceRequest type
  o.appendPhotoAlbum("photo1","Patient Album 1","../data/images/clinic/patient",["photomst","PATIENT","PHOTO1"]);
  o.appendPhotoAlbum("photo2","Patient Album 2","../data/images/clinic/patient1",["photomst","PATIENT","PHOTO2"]);
  o.drilldown.appendData("ssn","SSN",{inputMask:"[999-999-999]"});
  o.drilldown.appendRadio("gender","Gender",{M:"Male",F:"Female"},{isRequired:true});
  o.drilldown.appendData("dob","Date of Birth");
  o.drilldown.appendAge("dob","Age");
  o.drilldown.appendBoolean("billptonly","Bill Patient Only");
  o.drilldown.appendBoolean("sndstmnt","Send Statement");
  o.drilldown.appendData("hphone",["Home","Home Phone Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData("cellphone",["Cell","Cell Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData("fax",["Fax","Fax Number"],{inputMask:"![(999)] [999-9999]"});
  o.drilldown.groupFields("phonenumbers","Phone Numbers","hphone","cellphone","fax");
  o.drilldown.appendBoolean("asig",["Assignment","Assignment Signature"]);
  o.drilldown.appendBoolean("rs",["Release","Release Signature"]);
  o.drilldown.groupFields("sigs","Signatures","asig","rs");
  o.drilldown.appendReference("sdrmstid",["Primary","Primary Physician"],"sdrmst",["lname","fname","mi"],{type:"poptable"});
  o.drilldown.appendReference("rdrmstid",["Referring","Referring Physician"],"rdrmst",["lname","fname","mi"]);
  o.drilldown.groupFields("drs","Physicians","sdrmstid","rdrmstid");
  o.drilldown.appendSelect("statusid","Marital Status",["dfnmst","PATIENT","STATUSID"],{code:"code"});
  o.drilldown.appendSelect("studentid","Student Status",["dfnmst","PATIENT","STUDENT"],{code:"code"});
  o.drilldown.appendSelect("finclassid","Financial Class",["dfnmst","PATIENT","FINCLASSID"],{code:"code"});
  o.drilldown.appendReference("attorneyid","Attorney","attorney",["lname","fname","mi"]);
  o.drilldown.appendSelect("restypeid","Residence",["dfnmst","PATIENT","RESTYPEID"],{allowNew:true,code:"code",dataOrder:"code asc",isRequired:true});
  o.drilldown.appendSelect("mailcodeid","Mail Code",["dfnmst","PATIENT","MAILCODEID"],{allowNew:true,code:"code",dataOrder:"code asc",isRequired:true});
  o.drilldown.appendSelect("npsrcid","Source",["dfnmst","PATIENT","NPSRCID"],{isRequired:true,code:"code",allowNew:true});
  o.drilldown.appendSelect("relatetoid","Injury Related To",["dfnmst","PATIENT","RELATETOID"],{allowNew:true,code:"code",isRequired:true});
  o.drilldown.appendData("consdttm","First Consultation");
  o.drilldown.appendData("xraydttm","Initial X-Ray");
  o.drilldown.appendData("injurydttm","Injury Illness");
  o.drilldown.appendData("ssympdttm","Similar Symptom");
  o.drilldown.appendData("lstseendttm","Last Seen");
  o.drilldown.appendData("lstmensdttm","Last Menstruation");
  o.drilldown.appendData("retiredttm","Retirement");
  o.drilldown.appendData("collectdttm","To Collections");
  o.drilldown.appendData("inactvdttm","Inactive");
  o.drilldown.appendData("deathdttm","Death");
  o.drilldown.appendSelect("countryid","Country",["dfnmst","COUNTRY","COUNTRY"],{allowNew:true});
  o.drilldown.appendSelect("stateid","State",["dfnmst","STATE","STATE"],["countryid","linkmst","COUNTRY -> STATE"],{allowNew:true});
  o.drilldown.appendReference("refpatientid","Referred By","patient",["lname","fname","mi"]);
  o.drilldown.appendTreeview("itemid","Tree Item",["dfnmst","PATIENT","TV1"],["linkmst","PATIENT TV1"],{allowDeleteLinkedItems:true,allowNew:true,windowHeight:600,windowWidth:400});
  o.drilldown.appendFileVault("file","Patient File",["filemst","PATIENT","FILE1"],"../data/files/clinic/patient");
  o.drilldown.appendPicklist("icd9ids","Diagnosis","icd9mst",["linkmst","PATIENT ICD9ID"],{allowNew:true,dataOrder:"asc"});
  o.drilldown.appendData("notes","Notes");
  o.drilldown.appendCopyButton("backup","Backup Patient Data","patient_copy")

  o = app.gui.appendDataTable("insmst","Insurance Companies","Insurance Company");
  o.dataOrder = "name";
  o.appendData("name","Company Name");
  o.appendSelect("typeid","Type",["dfnmst","INSMST","TYPEID"],{allowNew:true,code:"code",isRequired:true});
  o.appendData("contact","Contact");
  o.appendData("phone","Phone Number",{inputMask:"![(999)] [999-9999]"});
  o.appendData("pext","Ext");
  o.appendMemoPreview("notes","Notes");
  o.drilldown.appendData("address1",["","Address"]);
  o.drilldown.appendData("address2",["","Address ..."],{editSize:"fieldWidth"});
  o.drilldown.appendData("city","City");
  o.drilldown.appendData("state","State");
  o.drilldown.appendData("zip","Zip");
  o.drilldown.groupFields("address","Address","address1","address2","city","state","zip");
  o.drilldown.appendData("fax","Fax Number",{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendData("cellphone","Cell Phone",{inputMask:"![(999)] [999-9999]"});
  o.drilldown.appendEmail("email","Email Address");
  o.drilldown.appendURL("website","Website");
  o.drilldown.appendData("ocnano","OCNA #");
  o.drilldown.appendRadio("bmethod","Billing Method",{1:"Electronic",2:"HCFA",3:"Invoice",4:"UB92"});
  o.drilldown.appendRadio("paysystem","Payment System",{1:"Fee For Service",2:"Capitated"});
  o.drilldown.appendData("payorid","Payor ID");
  o.drilldown.appendData("claimoffice","Claim Office");
  o.drilldown.appendReference("submitterid","Submitter","submtmst","name");
  o.drilldown.appendSelect("btypeid","Billing Type",["dfnmst","IBTYPEMST","BTYPEMSTID"],{allowNew:true,code:"code",isRequired:true});
  o.drilldown.appendData("notes","Notes",{rows:5});

  o = app.gui.appendDataTable("sdrmst","MDs","MD");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData("fname","First Name");
  o.appendData("mi","MI",{forceCase:"UPPER"});
  o.appendData("lname","Last Name");
  o.drilldown.appendPicklist("specialtyids","Specialties",["dfnmst","DRMST","CPSPECID"],["linkmst","SDRMST CPSPECID"],{allowNew:true,maxItems:5});

  o = app.gui.appendDataTable("rdrmst","Referring MDs","Referring MD");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData("fname","First Name");
  o.appendData("mi","MI",{forceCase:"UPPER"});
  o.appendData("lname","Last Name");

  o = app.gui.appendDataTable("attorney","Attorneys","Attorney");
  o.dbiScriptProperties.dataOrder = "lname,fname,mi";
  o.appendData("fname","First Name");
  o.appendData("mi","MI",{forceCase:"UPPER"});
  o.appendData("lname","Last Name");
  o.appendData("address1","Address");
  o.appendData("address2","Address ...");
  o.appendData("city","City");
  o.appendData("state","State");
  o.appendData("zip","Zip");

  o = app.gui.appendDataTable("submtmst","Submitters","Submitter");
  o.appendData("name","Company Name");
  o.appendData("phone","Phone Number",{inputMask:"![(999)] [999-9999]"});
  o.appendURL("website","Website");

  o = app.gui.appendDataTable("policymst","Insurance Policies","Insurance Policy","insmst:insmstid");
  o.appendData("insgroup","Insurance Group");
  o.appendData("termdttm","Term");
  o.appendReference("patientid","Policy Owner","patient",["lname","fname","mi"]);
  o.appendData("contract","Contract");
  o.appendSelect("policytypeid","Policy Type",["dfnmst","POLICYMST","POLICYTYPEID"],{allowNew:true,code:"code",isRequired:true});
  o.appendData("coverage","Service Code");
  o.appendMoney("deduct","Deductible");
  o.appendMoney("deductelse","Used Deductible");
  o.appendAggregateMoney("total","Total","tranprc","SUM(chargeins+chargepat)");
  o.drilldown.appendData("copaylvl1",["Initial","Initial Copay"]);
  o.drilldown.appendSelect("copaylvl1type",["","Initial Copay Type"],{$:"Dollars","%":"Percent"});
  o.drilldown.appendData("copaylvl2visits",["After [---] visits","Number of Visits Before Secondary Copay"]);
  o.drilldown.appendData("copaylvl2",["","Secondary Copay"]);
  o.drilldown.appendSelect("copaylvl2type",["","Secondary Copay Type"],{$:"Dollars","%":"Percent"});
  o.drilldown.groupFields("group1","Copay","copaylvl1","copaylvl1type","copaylvl2visits","copaylvl2","copaylvl2type");

  o = app.gui.appendDataTable("patpolicymst","Patient Policies","Patient Policy","patient:patientid,policymst:policymstid",0,1);
  o.appendRadio("typeid","Type",{1:"Primary",2:"Secondary",3:"Tertiary",4:"Archive"});
  o.appendSelect("relationid","Relation to Policy Owner",["dfnmst","POLICYMST","RELATIONID"],{allowNew:true,code:"code",isRequired:true});

  o = app.gui.appendDataTable("trandtl","Transactions","Transaction","patpolicymst:patpolicymstid");
  o.dbiScriptProperties.dataOrder = "servfrdttm desc";
  o.appendData("servfrdttm","Date Opened",{isUniqueWithinForeignKeys:true});
  o.appendData("claimno","Claim #");
  o.appendData("fileno","File #");
  o.appendData("contract","Contract #");
  o.appendData("coverage","Coverage");
  o.appendBoolean("aa","AA");
  o.appendAggregateMoney("total","Total","tranprc","SUM(chargeins+chargepat)");
  o.appendMemoPreview("notes","Notes",{displaySize:30});
  o.drilldown.appendData("notes","Notes");

  o = app.gui.appendDataTable("trandtl2","Disability","Disability","trandtl:trandtlid",0,1);
  o.appendData("totaldisabilityfrom","Total Disability From");
  o.appendData("totaldisabilityto","Total Disability To");
  o.appendData("partialdisabilityfrom","Partial Disability From");
  o.appendData("partialdisabilityto","Partial Disability To");
  o.appendData("offworkfrom","Off Work From");
  o.appendData("offworkto","Off Work To");

  o = app.gui.appendDataTable("trandtla","Ambulance","Ambulance","trandtl:trandtlid",0,1);
  o.appendData("miles","Miles");
  o.appendData("patweight","Patient Weight");
  o.appendData("origin","Origin");
  o.appendData("dest","Destination");
  o.appendData("purpose","Purpose");
  o.appendData("purposestretch","Purpose of Stretcher");

  o = app.gui.appendDataTable("patcharge","Copayments","Copayment","patient:patientid");
  o.dbiScriptProperties.dataOrder = "chargedttm desc";
  o.appendData("chargedttm","Date Charged");
  o.appendSelect("descriptionid","Description",["dfnmst","PATCHARGE","DESCRIPTIONID"],{allowNew:true});
  o.appendData("amount","Amount");

  o = app.gui.appendDataTable("patahst","Allergies","Allergy","patient:patientid");
  o.dbiScriptProperties.dataOrder = "detddttm desc";
  o.appendData("detddttm","Date Diagnosed");
  o.appendQuickpick("allergyid","Description",["dfnmst","ALLERGYMST","PID"],{allowNew:true,isRequired:true});

  o = app.gui.appendDataTable("patdhst","Medications","Medication","patient:patientid");
  o.dbiScriptProperties.dataOrder = "effdttm desc";
  o.appendData("effdttm","Date Prescribed");
  o.appendQuickpick("drugid","Description",["dfnmst","DRUGMST","PID"],{allowNew:true,isRequired:true});
  o.appendData("dosage","Dosage");
  o.appendData("dispense","Dispense");
  o.appendData("refill","Refill");
  o.appendBoolean("selectcode","Select Code");
  o.appendData("sig","Sig");

  o = app.gui.appendDataTable("tranprc","Procedures","Procedure","trandtl:trandtlid",1);
  o.dbiScriptProperties.dataOrder = "servtodttm desc";
  o.appendData("servtodttm","Date of Service");
  o.appendQuickpick("prcmstid","Procedure","prcmst");
  o.appendMoney("chargeins","Insurance");
  o.appendMoney("chargepat","Patient");
  o.appendMoney("charge","Total Charge");

  o = app.gui.addSystemTable("sysparam","System");
  o.appendData("taxrate","Tax Rate",{decimals:4});

}

function format_name(lname,fname,mi) { return lname + ", " + fname + (mi ? " " + mi + "." : ""); }

var patient_attorneyid_format   = format_name,
    patient_rdrmstid_format0    = format_name,
    patient_refpatientid_format = format_name,
    patient_sdrmstid_format     = format_name,
    policymst_patientid_format  = format_name;

function patient_button1_onclick(o) { window.open("http://maps.google.com/maps?q="+(o.address1+"+"+o.city+"+"+o.state).replace(/ /g,"+")); }
function patient_icons_calculate(o) { var a=[],p=/a/i; if(p.test(o.lname))a.push(0); if(p.test(o.address1))a.push(1); if(p.test(o.city))a.push(2); if(p.test(o.state))a.push(3); return a; }
function patient_inactvdttm_updateValue(s,t,i,j,k){if(s == "patient" && t == "inactv")return k ? new Date : undefined; return null;}
function patient_lstmensdttm_isDisplayed(o) { return o.gender == "F"; }
function patient_rdrmstid_format1(lname,fname,mi) { return fname + " " + (mi ? mi + ". " : "") + lname; }
function patient_stockPrice_calculateHttpData(o) { return {s:o.stock,f:"l1"}; }
function patient_stockPrice_processResponse(s) { var lastPrice = parseFloat(s); return isNaN(lastPrice) ? "" : "$" + lastPrice.toFixed(2); }

function insmst_email_setSubject(o) { return "Attn: Claim Office #" + o.claimoffice; }

function trandtl_servfrdttm_newValue() { return new Date; }

function trandtl2_isDisplayed(o) { return o.trandtl.aa; }

function patdhst_effdttm_newValue() { return new Date; }

function tranprc_charge_calculate(o) { return o.chargeins + o.chargepat; }
function tranprc_chargeins_validate(s) { return s > 100000 ? "Charge cannot exceed $100,000" : ""; }
function tranprc_chargeins_verify(s) { return s > 10000 ? "Charge exceeds $10,000." : ""; }
