
function dbiScriptApplication() {

  app.dbiScriptProperties.dataConfig = "../data/nwind.cfg"

  app.dbiScriptProperties.tables.fetchAll = false;

  var o = app.gui.appendDataTable("customer","Customers","Customer");
  o.appendData("companyName","Company Name");
  o.appendData("contactName","Contact Name");
  o.appendData("contactTitle","Contact Title");
  o.appendData("phone","Phone");
  o.appendData("fax","Fax");
  o.drilldown.appendData("address","Address");
  o.drilldown.appendData("city","City");
  o.drilldown.appendData("region","Region");
  o.drilldown.appendData("postalCode","Postal Code");
  o.drilldown.appendData("country","Country");

  o = app.gui.appendDataTable("employee","Employees","Employee");
  o.dbiScriptProperties.dataOrder = "lastName"
  o.appendData("salutation","Sal");
  o.appendData("firstName","First Name");
  o.appendData("lastName","Last Name");
  o.appendData("title","Title");
  o.appendData("extension","Ext");
  o.appendData("hireDate","Hire Date");
  o.appendData("homePhone","Home Phone");
  o.appendReference("reportsTo","Reports To","employee",["salutation","firstName","lastName"]);
  o.drilldown.appendData("address","Address");
  o.drilldown.appendData("city","City");
  o.drilldown.appendData("region","Region");
  o.drilldown.appendData("postalCode","Postal Code");
  o.drilldown.appendData("country","Country");
  o.drilldown.appendData("birthDate","Date of Birth");
  o.drilldown.appendData("notes","Notes");

  o = app.gui.appendDataTable("shipper","Shippers","Shipper");
  o.appendData("companyName","Company Name");
  o.appendData("phone","Phone");

  o = app.gui.appendDataTable("supplier","Suppliers","Supplier");
  o.appendData("companyName","Company Name");
  o.appendData("contactName","Contact Name");
  o.appendData("contactTitle","Contact Title");
  o.appendData("phone","Phone");
  o.appendData("fax","Fax");
  o.drilldown.appendData("address","Address");
  o.drilldown.appendData("city","City");
  o.drilldown.appendData("region","Region");
  o.drilldown.appendData("postalCode","Postal Code");
  o.drilldown.appendData("country","Country");
  o.drilldown.appendURL("homePage","Website");

  o = app.gui.appendDataTable("category","Categories","Category");
  o.appendData("categoryName","Category Name");
  o.appendData("description","Description");

  o = app.gui.appendDataTable("product","Products","Product","supplier:supplierid,category:categoryid");
  o.appendData("productName","Product Name");
  o.appendData("quantityPerUnit","Quantity Per Unit");
  o.appendData("unitPrice","Unit Price");
  o.appendData("unitsInStock","Units In Stock");
  o.appendData("unitsOnOrder","Units On Order");
  o.appendData("reorderLevel","Reorder Level");
  o.appendData("discontinued","Discontinued");

  o = app.gui.appendDataTable("order","Orders","Order","customer:customerid,employee:employeeid");
  o.appendData("orderDate","Order Date");
  o.appendData("requiredDate","Required Date");
  o.appendData("shippedDate","Shipped Date");
  o.appendReference("shipVia","Ship Via","shipper",["companyName"]);
  o.appendData("freight","Freight");
  o.appendData("shipName","Ship Name");
  o.appendAggregateMoney("total","Total","order item","SUM( unitPrice * quantity * (1 - discount) )");
  o.drilldown.appendData("shipAddress","Address");
  o.drilldown.appendData("shipCity","City");
  o.drilldown.appendData("shipRegion","Region");
  o.drilldown.appendData("shipPostalCode","Postal Code");
  o.drilldown.appendData("shipCountry","Country");
  o.drilldown.groupFields("sa","Shipped To","shipAddress","shipCity","shipRegion","shipPostalCode","shipCountry");

  o = app.gui.appendDataTable("order item","Order Items","Order Item","order:orderid",1);
  o.appendReference("productid","Product","product",["productName"]);
  o.appendData("unitPrice","Unit Price");
  o.appendData("quantity","Quantity");
  o.appendPercentage("discount","Discount",{decimals:2,maxValue:.5,minValue:0});
  o.appendMoney("total","Total")

}

function order_orderDate_newValue(){return new Date}

window["order item_unitPrice_updateValue"] = function (s,t,i,j,k,o,p) {
  if(s=="order item" && t=="productid") return Math.round(p.product.unitPrice * (1 - o.discount) * 100) / 100;
  if(s=="order item" && t=="discount") return Math.round(i / (1 - j) * (1 - k) * 100) / 100;
  return null;
}
window["order item_discount_verify"] = function(i){return i>.25 ? "Are you sure you want to give a " + (i * 100) + "% discount?" : "";}

window["order item_total_calculate"] = function(o){return o.unitPrice * o.quantity * (1 - o.discount);}